/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package model;

import java.io.IOException;
import java.io.RandomAccessFile;
import java.io.Serializable;

/**
 *
 * @author Gianni
 */
public class RaPersona extends Persona {
  public static final int SIZE = 68;
  private static final int NAMESIZE = 15;

  public RaPersona(String nome, String cognome, double peso) {
    super(nome, cognome, peso);
  }
  public RaPersona() {
    this("", "", 0.0);
  }
  
  public void read(RandomAccessFile f) throws IOException {
    setNome(readName(f));
    setCognome(readName(f));
    setPeso(f.readDouble());
  }

  private String readName(RandomAccessFile f) throws IOException {
    char name[]=new char[NAMESIZE];
    for (int i = 0; i < name.length; i++) {
      name[i]=f.readChar();   
    }    
    return new String(name).replace('\0',' ').trim();
  }

  public void write(RandomAccessFile f) throws IOException {
    writeName(f,getNome());
    writeName(f,getCognome());
    f.writeDouble(getPeso());
  }

  private void writeName(RandomAccessFile f,String n) throws IOException {
    StringBuffer buffer =null;
    if (n!=null){
      buffer=new StringBuffer(n);
      buffer.setLength(NAMESIZE);
    }
    else {
      buffer=new StringBuffer(NAMESIZE);
    }
    f.writeChars(buffer.toString());
  }

}
